/******************************** -*- C -*- ****************************
 *
 *	Translator to native code declarations.
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 * Copyright 1988-92, 1994-95, 1999-2001 Free Software Foundation, Inc.
 * Written by Paolo Bonzini.
 *
 * This file is part of GNU Smalltalk.
 *
 * GNU Smalltalk is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later 
 * version.
 * 
 * GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 ***********************************************************************/

#ifndef __GSTXLAT__
#define __GSTXLAT__


#include "gst.h"

#ifdef USE_JIT_TRANSLATION

struct InlineCacheStruct;
struct IPMapStruct;
typedef struct MethodEntryStruct {
  struct MethodEntryStruct *next;
  OOP			    methodOOP;
  OOP			    receiverClass;
  struct InlineCacheStruct *inlineCaches;
  struct IPMapStruct       *ipMap;
  int			    nativeCode[1];	/* type chosen randomly */
} MethodEntry;

extern voidPtr		getNativeCode(), mapVirtualIP();

extern void		freeReleasedNativeCode(), releaseNativeCode(),
			discardNativeCode(), initTranslator();

extern voidPtr		(*runNativeCode)(), (*returnFromNativeCode)();

#define getMethodEntry(nativeCodeStart) ((MethodEntry *) (		\
  ((char *) nativeCodeStart) - (sizeof(MethodEntry) - sizeof(int))  ))

#define isValidIP(nativeCodeStart) 					\
  (getMethodEntry(nativeCodeStart)->receiverClass)

#endif

#endif
